# Create a field given a existing stream name in clickhouse database Source: https://bytebeam.io/docs/api-reference/admin/create-a-field-given-a-existing-stream-name-in-clickhouse-database post /api/v1/streams/fields # Create a new apikey Source: https://bytebeam.io/docs/api-reference/admin/create-a-new-apikey post /api/v1/apikeys # Create a new user Source: https://bytebeam.io/docs/api-reference/admin/create-a-new-user post /api/v1/users # Create role Source: https://bytebeam.io/docs/api-reference/admin/create-role post /api/v1/roles # Creates a stream on clickhouse database Source: https://bytebeam.io/docs/api-reference/admin/creates-a-stream-on-clickhouse-database post /api/v1/streams # Creates computed stream Source: https://bytebeam.io/docs/api-reference/admin/creates-computed-stream post /api/v1/streams/computed_streams # Deactivate an apikey; soft-delete Source: https://bytebeam.io/docs/api-reference/admin/deactivate-an-apikey;-soft-delete delete /api/v1/apikeys/{key-or-name} # Delete a field given existing stream name in clickhouse database Source: https://bytebeam.io/docs/api-reference/admin/delete-a-field-given-existing-stream-name-in-clickhouse-database delete /api/v1/streams/{stream-name}/fields/{field-name} # Delete a stream on clickhouse database Source: https://bytebeam.io/docs/api-reference/admin/delete-a-stream-on-clickhouse-database delete /api/v1/streams/{stream-name} # Delete a user given existing id Source: https://bytebeam.io/docs/api-reference/admin/delete-a-user-given-existing-id delete /api/v1/users/{user-id} # Delete role given role-id Source: https://bytebeam.io/docs/api-reference/admin/delete-role-given-role-id delete /api/v1/roles/{role-id} # Get a single role given role-id Source: https://bytebeam.io/docs/api-reference/admin/get-a-single-role-given-role-id get /api/v1/roles/{role-id} # Get all apikeys Source: https://bytebeam.io/docs/api-reference/admin/get-all-apikeys get /api/v1/apikeys # Get all existing streams in clickhouse database Source: https://bytebeam.io/docs/api-reference/admin/get-all-existing-streams-in-clickhouse-database get /api/v1/streams # Get all fields given existing stream name in clickhouse database Source: https://bytebeam.io/docs/api-reference/admin/get-all-fields-given-existing-stream-name-in-clickhouse-database get /api/v1/streams/{stream-name}/fields # null Source: https://bytebeam.io/docs/api-reference/admin/get-apiv1streamsqueries get /api/v1/streams/queries/{query-id} # null Source: https://bytebeam.io/docs/api-reference/admin/get-apiv1streamsqueries-1 get /api/v1/streams/queries # Get current User object Source: https://bytebeam.io/docs/api-reference/admin/get-current-user-object get /api/v1/me # Get list of roles Source: https://bytebeam.io/docs/api-reference/admin/get-list-of-roles get /api/v1/roles # Get settings Source: https://bytebeam.io/docs/api-reference/admin/get-settings get /api/v1/server/settings # Get user given existing id Source: https://bytebeam.io/docs/api-reference/admin/get-user-given-existing-id get /api/v1/users/{user-id} # Get users and their roles Source: https://bytebeam.io/docs/api-reference/admin/get-users-and-their-roles get /api/v1/users # null Source: https://bytebeam.io/docs/api-reference/admin/post-apiv1streamsfixprotobuff post /api/v1/streams/fixprotobuff # Rename a stream field Source: https://bytebeam.io/docs/api-reference/admin/rename-a-stream-field put /api/v1/streams/{stream-name}/fields/{field-name}/rename # Return full detail of streams with fields including if they are computed, along with their code and parent streams Source: https://bytebeam.io/docs/api-reference/admin/return-full-detail-of-streams-with-fields-including-if-they-are-computed-along-with-their-code-and-parent-streams get /api/v1/streams/detailed # Return protobuff for all streams in clickhouse database Source: https://bytebeam.io/docs/api-reference/admin/return-protobuff-for-all-streams-in-clickhouse-database get /api/v1/streams/protobuff # Update a user given existing id Source: https://bytebeam.io/docs/api-reference/admin/update-a-user-given-existing-id put /api/v1/users/{user-id} # Update an existing field's type Source: https://bytebeam.io/docs/api-reference/admin/update-an-existing-fields-type post /api/v1/streams/fields/update # Update role given role-id Source: https://bytebeam.io/docs/api-reference/admin/update-role-given-role-id put /api/v1/roles/{role-id} # Update tenant settings Source: https://bytebeam.io/docs/api-reference/admin/update-tenant-settings put /api/v1/me/tenant/settings # Update user settings Source: https://bytebeam.io/docs/api-reference/admin/update-user-settings put /api/v1/me/settings # append fixed-list phase to a schedule Source: https://bytebeam.io/docs/api-reference/append-fixed-list-phase-to-a-schedule post /api/v1/actions/{action_id}/append_phase # Called by dkron repeatedly for a scheduled action until it is finished. It retries failed actions if needed and updates schedule status Source: https://bytebeam.io/docs/api-reference/called-by-dkron-repeatedly-for-a-scheduled-action-until-it-is-finished-it-retries-failed-actions-if-needed-and-updates-schedule-status post /api/v1/dkron/update-schedule-status/{action_id} # Create a new tenant Source: https://bytebeam.io/docs/api-reference/create-a-new-tenant post /api/v1/tenants # Create alert notification rule Source: https://bytebeam.io/docs/api-reference/create-alert-notification-rule post /api/v1/alert-rules/{id}/alert-notification-rules # Create alert rule Source: https://bytebeam.io/docs/api-reference/create-alert-rule post /api/v1/alert-rules # Create session type Source: https://bytebeam.io/docs/api-reference/create-session-type post /api/v1/session-types # Creates a DBC Source: https://bytebeam.io/docs/api-reference/creates-a-dbc post /api/v1/dbcs # Create a new file (respects RBAC) Source: https://bytebeam.io/docs/api-reference/data/create-a-new-file-respects-rbac post /api/v1/file # Create dashboard API Source: https://bytebeam.io/docs/api-reference/data/create-dashboard-api post /api/v1/dashboards # Delete dashboard API Source: https://bytebeam.io/docs/api-reference/data/delete-dashboard-api delete /api/v1/dashboards/{id} # Get dashboard API Source: https://bytebeam.io/docs/api-reference/data/get-dashboard-api get /api/v1/dashboards/{id} # Get dashboards API Source: https://bytebeam.io/docs/api-reference/data/get-dashboards-api get /api/v1/dashboards # Get data for a single panel given in the body Source: https://bytebeam.io/docs/api-reference/data/get-data-for-a-single-panel-given-in-the-body post /api/v1/panel-data-csv # Get data for panels given in body Source: https://bytebeam.io/docs/api-reference/data/get-data-for-panels-given-in-body post /api/v1/panel-data # Return the list of all uploaded files (respects RBAC) Source: https://bytebeam.io/docs/api-reference/data/return-the-list-of-all-uploaded-files-respects-rbac get /api/v1/file # The Endpoint the device hits to download the file (respects RBAC) Source: https://bytebeam.io/docs/api-reference/data/the-endpoint-the-device-hits-to-download-the-file-respects-rbac get /api/v1/file/{id}/artifact # Update dashboard Source: https://bytebeam.io/docs/api-reference/data/update-dashboard post /api/v1/dashboards/{id} # Delete a single DBC given id Source: https://bytebeam.io/docs/api-reference/delete-a-single-dbc-given-id delete /api/v1/dbcs/{dbc-id} # Delete alert notification rule Source: https://bytebeam.io/docs/api-reference/delete-alert-notification-rule delete /api/v1/alert-rules/{alert-id}/alert-notification-rules/{notification-id} # Delete alert rule Source: https://bytebeam.io/docs/api-reference/delete-alert-rule delete /api/v1/alert-rules/{id} # null Source: https://bytebeam.io/docs/api-reference/delete-apiv1firmware-bundlesid delete /api/v1/firmware-bundles/id/{firmware-bundle-id} # null Source: https://bytebeam.io/docs/api-reference/delete-apiv1firmware-bundlesversion delete /api/v1/firmware-bundles/version/{version} # Delete session type Source: https://bytebeam.io/docs/api-reference/delete-session-type delete /api/v1/session-types/{name} # Detailed data for micelio stats panel Source: https://bytebeam.io/docs/api-reference/detailed-data-for-micelio-stats-panel post /api/v1/micelio-stats-panel-details # Allows update status of a device Source: https://bytebeam.io/docs/api-reference/devices/allows-update-status-of-a-device put /api/v1/devices/{device-id} # Approve an action Source: https://bytebeam.io/docs/api-reference/devices/approve-an-action put /api/v1/actions/{id}/approve # Attempt cancelling this action Source: https://bytebeam.io/docs/api-reference/devices/attempt-cancelling-this-action post /api/v1/actions/{action_id}/cancel # Create a metadata-key Source: https://bytebeam.io/docs/api-reference/devices/create-a-metadata-key post /api/v1/devices/metadata-keys # Create firmware version Source: https://bytebeam.io/docs/api-reference/devices/create-firmware-version post /api/v1/firmwares # Create new Device Configuration Source: https://bytebeam.io/docs/api-reference/devices/create-new-device-configuration post /api/v1/device-configs # Creates a new action-type Source: https://bytebeam.io/docs/api-reference/devices/creates-a-new-action-type post /api/v1/action-types # Delete a metadata-key Source: https://bytebeam.io/docs/api-reference/devices/delete-a-metadata-key delete /api/v1/devices/metadata-keys/{metadata-key} # Delete an action-type Source: https://bytebeam.io/docs/api-reference/devices/delete-an-action-type delete /api/v1/action-types/{action-type-name} # Download a firmware by component name and version Source: https://bytebeam.io/docs/api-reference/devices/download-a-firmware-by-component-name-and-version get /api/v1/firmwares/component/{component-name}/{version-number}/artifact # Download a firmware by version Source: https://bytebeam.io/docs/api-reference/devices/download-a-firmware-by-version get /api/v1/firmwares/{version-number}/artifact # Download cert for a device given device-id Source: https://bytebeam.io/docs/api-reference/devices/download-cert-for-a-device-given-device-id get /api/v1/devices/{device-id}/cert # Find devices by device state keys Source: https://bytebeam.io/docs/api-reference/devices/find-devices-by-device-state-keys get /api/v1/devices/search # Get a list of metadata-keys Source: https://bytebeam.io/docs/api-reference/devices/get-a-list-of-metadata-keys get /api/v1/devices/metadata-keys # Get action for device Source: https://bytebeam.io/docs/api-reference/devices/get-action-for-device get /api/v1/actions/{id} # null Source: https://bytebeam.io/docs/api-reference/devices/get-apiv1actions-device-latenciesstates get /api/v1/actions/{action-id}/device-latencies/states # null Source: https://bytebeam.io/docs/api-reference/devices/get-apiv1actions-error-stats get /api/v1/actions/{id}/error-stats # Get device config by version name Source: https://bytebeam.io/docs/api-reference/devices/get-device-config-by-version-name get /api/v1/device-configs/{version-name} # Get params for an action Source: https://bytebeam.io/docs/api-reference/devices/get-params-for-an-action get /api/v1/actions/{id}/params # Get the list of Device Configurations Source: https://bytebeam.io/docs/api-reference/devices/get-the-list-of-device-configurations get /api/v1/device-configs # Get the list of devices - paginated. Source: https://bytebeam.io/docs/api-reference/devices/get-the-list-of-devices--paginated get /api/v1/devices # null Source: https://bytebeam.io/docs/api-reference/devices/head-endpoint-to-check-metadata-about-file-download head /api/v1/firmwares/{version-number}/artifact # null Source: https://bytebeam.io/docs/api-reference/devices/head-endpoint-to-check-metadata-about-file-download-1 head /api/v1/firmwares/component/{component-name}/{version-number}/artifact # Mark a subset of devices for an action as completed Source: https://bytebeam.io/docs/api-reference/devices/mark-a-subset-of-devices-for-an-action-as-completed put /api/v1/actions/{id}/mark_as_completed # Mark all actions for devices matching the filters as completed Source: https://bytebeam.io/docs/api-reference/devices/mark-all-actions-for-devices-matching-the-filters-as-completed put /api/v1/actions/mark_as_completed # Mark an existing metadata-key as serial number Source: https://bytebeam.io/docs/api-reference/devices/mark-an-existing-metadata-key-as-serial-number put /api/v1/devices/metadata-keys/{existing-key}/mark-as-serial # Mark an existing metadata-key as serial number Source: https://bytebeam.io/docs/api-reference/devices/mark-an-existing-metadata-key-as-serial-number-1 put /api/v1/devices/metadata-keys/{existing-key}/unmark-as-serial # null Source: https://bytebeam.io/docs/api-reference/devices/post-apiv1actions-device-latencies post /api/v1/actions/{action_id}/device-latencies # Provision a device. returns cert & keys Source: https://bytebeam.io/docs/api-reference/devices/provision-a-device-returns-cert-&-keys post /api/v1/devices/provision # Request to trigger actions; someone with permission will approve Source: https://bytebeam.io/docs/api-reference/devices/request-to-trigger-actions;-someone-with-permission-will-approve post /api/v1/actions/request # Retry an action on some devices Source: https://bytebeam.io/docs/api-reference/devices/retry-an-action-on-some-devices post /api/v1/actions/{action_id}/retry # Return all pending actions for devices matching the given filters Source: https://bytebeam.io/docs/api-reference/devices/return-all-pending-actions-for-devices-matching-the-given-filters post /api/v1/pending-actions # Return logs of actions per device Source: https://bytebeam.io/docs/api-reference/devices/return-logs-of-actions-per-device get /api/v1/actions/{action-id}/device_actions/{device-id}/logs # Return paginated progress of actions per device Source: https://bytebeam.io/docs/api-reference/devices/return-paginated-progress-of-actions-per-device get /api/v1/actions/{id}/device_actions # Return stats about the progress of various devices this action was triggered on Source: https://bytebeam.io/docs/api-reference/devices/return-stats-about-the-progress-of-various-devices-this-action-was-triggered-on get /api/v1/actions/{id}/progress_histogram # Return the count of devices for pagination Source: https://bytebeam.io/docs/api-reference/devices/return-the-count-of-devices-for-pagination get /api/v1/devices/count # Return the list of all firmware versions of given component Source: https://bytebeam.io/docs/api-reference/devices/return-the-list-of-all-firmware-versions-of-given-component get /api/v1/firmwares/component/{component-name} # Return the list of all firmwares Source: https://bytebeam.io/docs/api-reference/devices/return-the-list-of-all-firmwares get /api/v1/firmwares # Return the list of firmwares for components Source: https://bytebeam.io/docs/api-reference/devices/return-the-list-of-firmwares-for-components get /api/v1/firmwares/components # Returns a csv file template for updating metadata for a device Source: https://bytebeam.io/docs/api-reference/devices/returns-a-csv-file-template-for-updating-metadata-for-a-device get /api/v1/devices/metadata-bulk-template # Returns a list of all action types Source: https://bytebeam.io/docs/api-reference/devices/returns-a-list-of-all-action-types get /api/v1/action-types # Takes a csv file and updates the metadata for a device Source: https://bytebeam.io/docs/api-reference/devices/takes-a-csv-file-and-updates-the-metadata-for-a-device post /api/v1/devices/metadata-bulk # Trigger an action on a bunch of devices. Source: https://bytebeam.io/docs/api-reference/devices/trigger-an-action-on-a-bunch-of-devices post /api/v1/actions # Update metadata(s) for a device(s) Source: https://bytebeam.io/docs/api-reference/devices/update-metadatas-for-a-devices post /api/v1/devices/metadata # Updates an existing action type Source: https://bytebeam.io/docs/api-reference/devices/updates-an-existing-action-type put /api/v1/action-types/{action-type-name}/reactivate # Updates an existing action type Source: https://bytebeam.io/docs/api-reference/devices/updates-an-existing-action-type-1 put /api/v1/action-types/{action-type-name} # Updates firmware version to be activated or deactivated Source: https://bytebeam.io/docs/api-reference/devices/updates-firmware-version-to-be-activated-or-deactivated put /api/v1/firmwares/{version-number} # Updates firmware version to be activated or deactivated Source: https://bytebeam.io/docs/api-reference/devices/updates-firmware-version-to-be-activated-or-deactivated-1 put /api/v1/firmwares/component/{component-name}/{version-number} # Find devices by device state keys Source: https://bytebeam.io/docs/api-reference/find-devices-by-device-state-keys get /api/v2/devices/search # Get alert notification rule Source: https://bytebeam.io/docs/api-reference/get-alert-notification-rule get /api/v1/alert-rules/{alert-id}/alert-notification-rules/{notification-id} # Get all alert groups Source: https://bytebeam.io/docs/api-reference/get-all-alert-groups get /api/v1/alert-groups # Get all alert rules Source: https://bytebeam.io/docs/api-reference/get-all-alert-rules get /api/v1/alert-rules # Get all alert types Source: https://bytebeam.io/docs/api-reference/get-all-alert-types get /api/v1/alert-types # Get all audit Logs Source: https://bytebeam.io/docs/api-reference/get-all-audit-logs get /mock/logs # Get all DBCs for tenant Source: https://bytebeam.io/docs/api-reference/get-all-dbcs-for-tenant get /api/v1/dbcs # Get all device components Source: https://bytebeam.io/docs/api-reference/get-all-device-components get /api/v1/device_components # Get all Role logs Source: https://bytebeam.io/docs/api-reference/get-all-role-logs get /mock/logs/roles # Get all session types Source: https://bytebeam.io/docs/api-reference/get-all-session-types get /api/v1/session-types # Get all the Dashboard logs Source: https://bytebeam.io/docs/api-reference/get-all-the-dashboard-logs get /mock/logs/dashboard # Get all the Metadata logs Source: https://bytebeam.io/docs/api-reference/get-all-the-metadata-logs get /mock/logs/metadata # null Source: https://bytebeam.io/docs/api-reference/get-apiv1devicesstate-keys get /api/v1/devices/state-keys # null Source: https://bytebeam.io/docs/api-reference/get-apiv1firmware-bundles get /api/v1/firmware-bundles # null Source: https://bytebeam.io/docs/api-reference/get-apiv1firmware-bundles-artifact get /api/v1/firmware-bundles/{firmware-bundle-id}/artifact # null Source: https://bytebeam.io/docs/api-reference/get-apiv1firmware-bundlesid get /api/v1/firmware-bundles/id/{firmware-bundle-id} # null Source: https://bytebeam.io/docs/api-reference/get-apiv1firmware-bundlesversion get /api/v1/firmware-bundles/version/{version} # null Source: https://bytebeam.io/docs/api-reference/get-apiv1log-tags get /api/v1/log-tags # Get auth details given tenant id Source: https://bytebeam.io/docs/api-reference/get-auth-details-given-tenant-id get /api/v1/tenants/{tenant-id}/auth # Get dbc file for a DBC given id Source: https://bytebeam.io/docs/api-reference/get-dbc-file-for-a-dbc-given-id get /api/v1/dbcs/{dbc-id}/dbc # Get device actions given device id Source: https://bytebeam.io/docs/api-reference/get-device-actions-given-device-id get /api/v1/devices/{device_id}/actions # Get info about a single DBC given id Source: https://bytebeam.io/docs/api-reference/get-info-about-a-single-dbc-given-id get /api/v1/dbcs/{dbc-id} # Get list of timezones supported by dashboard CSV export Source: https://bytebeam.io/docs/api-reference/get-list-of-timezones-supported-by-dashboard-csv-export get /api/v1/timezones # null Source: https://bytebeam.io/docs/api-reference/get-logout get /logout # Get logs of a role Source: https://bytebeam.io/docs/api-reference/get-logs-of-a-role get /mock/logs/role/{role-name} # Get logs of a specific dashboard Source: https://bytebeam.io/docs/api-reference/get-logs-of-a-specific-dashboard get /mock/logs/dashboard/{dashboard-id} # Get metadata key and available options Source: https://bytebeam.io/docs/api-reference/get-metadata-key-and-available-options get /api/v1/devices/filter-options # Get Metadata log for a key Source: https://bytebeam.io/docs/api-reference/get-metadata-log-for-a-key get /mock/logs/metadata/{metadata-key} # null Source: https://bytebeam.io/docs/api-reference/get-metrics get /metrics # null Source: https://bytebeam.io/docs/api-reference/get-mockapiv1actions get /mock/api/v1/actions/{id} # Get parsed version of a DBC given id Source: https://bytebeam.io/docs/api-reference/get-parsed-version-of-a-dbc-given-id get /api/v1/dbcs/{dbc-id}/json # get schedule for an action Source: https://bytebeam.io/docs/api-reference/get-schedule-for-an-action get /api/v1/actions/{action_id}/schedule # Get share options for the user Source: https://bytebeam.io/docs/api-reference/get-share-options-for-the-user get /api/v1/dashboard-share-options # Get tables and columns available for querying Source: https://bytebeam.io/docs/api-reference/get-tables-and-columns-available-for-querying get /api/v1/stream_info # Get the list of devices - paginated. Source: https://bytebeam.io/docs/api-reference/get-the-list-of-devices--paginated get /api/v2/devices # null Source: https://bytebeam.io/docs/api-reference/head-apiv1firmware-bundles-artifact head /api/v1/firmware-bundles/{firmware-bundle-id}/artifact # Just a test route Source: https://bytebeam.io/docs/api-reference/just-a-test-route get /mock/test # Logs for device certifactes Source: https://bytebeam.io/docs/api-reference/logs/logs-for-device-certifactes get /api/v1/logs/device-certs # Logs for device certifactes by device id Source: https://bytebeam.io/docs/api-reference/logs/logs-for-device-certifactes-by-device-id get /api/v1/logs/device-certs/{device-id} # Mark all device actions given device id as completed Source: https://bytebeam.io/docs/api-reference/mark-all-device-actions-given-device-id-as-completed put /api/v1/devices/{id}/actions/mark_as_completed # Ping-pong end point Source: https://bytebeam.io/docs/api-reference/ping-pong-end-point get /ping # null Source: https://bytebeam.io/docs/api-reference/post-apiv1dbcs-diff post /api/v1/dbcs/{dbc-id}/diff # null Source: https://bytebeam.io/docs/api-reference/post-apiv1firmware-bundles post /api/v1/firmware-bundles # null Source: https://bytebeam.io/docs/api-reference/post-mockapiv1actions post /mock/api/v1/actions # null Source: https://bytebeam.io/docs/api-reference/post-mockapiv2actions post /mock/api/v2/actions # null Source: https://bytebeam.io/docs/api-reference/put-apiv1dbcs-update put /api/v1/dbcs/{dbc-id}/update # null Source: https://bytebeam.io/docs/api-reference/put-apiv1firmware-bundlesid put /api/v1/firmware-bundles/id/{firmware-bundle-id} # null Source: https://bytebeam.io/docs/api-reference/put-apiv1firmware-bundlesversion put /api/v1/firmware-bundles/version/{version} # Request authorization for tenant Source: https://bytebeam.io/docs/api-reference/request-authorization-for-tenant post /api/v1/auth-end-user # Returns available filters for searching actions of a device Source: https://bytebeam.io/docs/api-reference/returns-available-filters-for-searching-actions-of-a-device get /api/v1/devices/{device_id}/actions/filter-options # Returns list of tenants Source: https://bytebeam.io/docs/api-reference/returns-list-of-tenants get /api/v1/tenants # Search device by metadata Source: https://bytebeam.io/docs/api-reference/search-device-by-metadata post /api/v1/devices/search # Show overall progress of actions triggered Source: https://bytebeam.io/docs/api-reference/show-overall-progress-of-actions-triggered get /api/v1/actions # Start alert rule Source: https://bytebeam.io/docs/api-reference/start-alert-rule put /api/v1/alert-rules/{id}/start # Start Parser Source: https://bytebeam.io/docs/api-reference/start-parser put /api/v1/dbcs/{dbc-id}/start # Start session type Source: https://bytebeam.io/docs/api-reference/start-session-type put /api/v1/session-types/{name}/start # Stop alert rule Source: https://bytebeam.io/docs/api-reference/stop-alert-rule put /api/v1/alert-rules/{id}/stop # Stop Parser Source: https://bytebeam.io/docs/api-reference/stop-parser put /api/v1/dbcs/{dbc-id}/stop # Stop session type Source: https://bytebeam.io/docs/api-reference/stop-session-type put /api/v1/session-types/{name}/stop # Store tenant's end user authentication method Source: https://bytebeam.io/docs/api-reference/store-tenants-end-user-authentication-method put /api/v1/tenants/{tenant-id}/auth # Takes a filter and returns parameters matching that filter Source: https://bytebeam.io/docs/api-reference/takes-a-filter-and-returns-parameters-matching-that-filter get /api/v1/actions/filter-options # Test alert notification rule Source: https://bytebeam.io/docs/api-reference/test-alert-notification-rule post /api/v1/alert-rules/{id}/test-alert-notification-rule # Update alert notification rule Source: https://bytebeam.io/docs/api-reference/update-alert-notification-rule put /api/v1/alert-rules/{alert-id}/alert-notification-rules/{notification-id} # Update alert rule Source: https://bytebeam.io/docs/api-reference/update-alert-rule put /api/v1/alert-rules/{id} # Update DBC settings Source: https://bytebeam.io/docs/api-reference/update-dbc-settings put /api/v1/dbcs/{dbc-id} # Updates the status of the action triggered on the device Source: https://bytebeam.io/docs/api-reference/updates-the-status-of-the-action-triggered-on-the-device post /api/v1/devices/action/status # Connect to Bytebeam cloud Source: https://bytebeam.io/docs/device-side-integrations/android/connect-to-bytebeam-cloud Learn how to connect your device to the Bytebeam cloud with this step-by-step guide. Start by creating an account on Bytebeam, then download the device configuration JSON file. Rename the file to "device.json" and store it in the "download" partition of your device. This page assumes that you have gone through the [Getting Started guide](https://bytebeamio.mintlify.app/getting-started/signup) for creating an account. # Provisioning the device Each device needs to be provisioned with a unique JSON file `device.json` that is used for authentication. Refer to the [Device Provisioning Guide](https://bytebeamio.mintlify.app/platform-guide/device-management/provisioning-a-device) to download the device configuration file. Rename the downloaded file to device.json and place it in the uplink data directory (/data/local/tmp/uplink in the example setup). # Running Uplink The entry point of the example setup is `service.sh`. You should ensure that it's started at boot with the correct privileges. In an AOSP setup, it would be done by adding a system service ([https://android.googlesource.com/platform/system/core/+/master/init/README.md](https://android.googlesource.com/platform/system/core/+/master/init/README.md)). # Customising device shadow Source: https://bytebeam.io/docs/device-side-integrations/android/customising-device-shadow Learn about streams and device shadows in client applications with this document. Discover how default parameters like timestamp and sequence number are pushed to the device shadow stream. Explore the possibility of creating custom device shadow streams with additional fields. Every project in Bytebeam comes with a default [Device Shadow](https://bytebeamio.mintlify.app/getting-started/device-shadow) stream. The stream by default contains just three fields `Status`, `timestamp`, and `sequence`. This guide shows how to create additional fields and write data to this stream from your application. For that, Click on the **username** at the top right corner of the Bytebeam  cloud console and navigate to **Settings**  Here under the **Stream** Tab, you can find “**device\_shadow**” For example, add two new columns `device_name` and `arch` to the device shadow. You can do this by entering the field name and type and clicking the + button. After adding both fields your device shadow will look like the below: Now update your application to push this data to the device. :::codeblocktabs ```python theme={null} import socket import json import time s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) s.connect(("localhost", 5050)) # Constructs a payload and sends it over TCP to uplink def send_data(s, payload): send = json.dumps(payload) + "\n" s.sendall(bytes(send, encoding="utf-8")) # Add more parameters to device shadow def send_device_shadow(s, sequence): timestamp = int(time.time() * 1000) payload = { "stream": "device_shadow", "sequence": sequence, "timestamp": timestamp, "device_name": "Beaglebone Black Rev. C", "arch": "armv7", } print(payload) send_data(s, payload) print("Starting Uplink Bridge App") sequence = 1 while True: time.sleep(10) send_device_shadow(s, sequence) sequence += 1 ``` ```javascript theme={null} const net = require("net"); // Connect to the server const client = new net.Socket(); client.connect(5050, "localhost", () => { console.log("Connected to server"); }); // Constructs a payload and sends it over TCP to uplink function sendData(payload) { const send = JSON.stringify(payload) + "\n"; client.write(send); } // Send device shadow data function sendDeviceShadow(sequence) { let timestamp = Date.now(); let payload = { stream: "device_shadow", sequence: sequence, timestamp: timestamp, device_name: "Beaglebone Black Rev. C", arch: "armv7", }; console.log(payload); sendData(payload); } console.log("Starting Uplink Bridge App"); let sequence = 1; setInterval(() => { sendDeviceShadow(sequence); sequence++; }, 10000); ``` ```rust theme={null} use std::net::TcpStream; use std::io::{Read, Write}; use std::thread; use std::time::{Duration, SystemTime}; use serde_json::{Value, json}; async fn send_data(mut stream: &TcpStream, payload: serde_json::Value) { let send = format!("{}\n", payload.to_string()); stream.write_all(send.as_bytes()).await.unwrap(); } async fn send_device_shadow(mut stream: &TcpStream, sequence: u64) { let timestamp = SystemTime::now() .duration_since(SystemTime::UNIX_EPOCH) .unwrap() .as_millis(); let payload = json!({ "stream": "device_shadow", "sequence": sequence, "timestamp": timestamp, "device_name": "Beaglebone Black Rev. C", "arch": "armv7" }); println!("{:?}", payload); send_data(&mut stream, payload).await; } #[tokio::main] async fn main() { let addr = "localhost:5050"; let mut stream = TcpStream::connect(&addr).await.unwrap(); println!("Starting Uplink Bridge App"); let mut sequence = 1; loop { thread::sleep(Duration::from_secs(5)); send_device_shadow(&mut stream, sequence); sequence += 1; } } ``` ```go theme={null} package main import ( "encoding/json" "fmt" "net" "os" "strconv" "time" ) // DeviceShadow represents the payload structure type DeviceShadow struct { Stream string `json:"stream"` Sequence int `json:"sequence"` Timestamp int64 `json:"timestamp"` DeviceName string `json:"device_name"` Arch string `json:"arch"` } func sendData(conn net.Conn, payload interface{}) { data, _ := json.Marshal(payload) fmt.Println(string(data)) conn.Write(append(data, '\n')) } // sendDeviceShadow constructs and sends a device shadow payload func sendDeviceShadow(conn net.Conn, sequence int) { t := time.Now().UnixNano() / int64(time.Millisecond) payload := DeviceShadow{ Stream: "device_shadow", Sequence: sequence, Timestamp: t, DeviceName: "Beaglebone Black Rev. C", Arch: "armv7", } fmt.Println(payload) sendData(conn, payload)(conn, payload) } func main() { conn, err := net.Dial("tcp", "localhost:5050") if err != nil { fmt.Println("Error connecting:", err.Error()) os.Exit(1) } defer conn.Close() fmt.Println("Starting Uplink Bridge App") sequence := 1 for { time.Sleep(5 * time.Second) sendDeviceShadow(conn, sequence) sequence++ } } ``` ::: You should now be able to see the new fields on Bytebeam cloud: # Device Setup Source: https://bytebeam.io/docs/device-side-integrations/android/device-setup Learn how to setup our device sdk on your android devices [uplink](https://github.com/bytebeamio/uplink) is our device side sdk. It is an executable that is supposed to run on the device as a system service. It will handle communication with our backend, buffering of uploaded data to disk in case of bad network, OTAs and features like remote shell. You can check out an example setup for android [here](https://github.com/bytebeamio/uplink/tree/main/examples/android). The entry point for this example setup is `service.sh`. There are a couple of configuration options in `env.sh`. # Disk Stats Source: https://bytebeam.io/docs/device-side-integrations/android/monitoring-your-device/disk-stats Learn how to view storage device details, such as available space and total size, with this comprehensive document. Explore the "Disk Stats" section and discover the corresponding stream, "uplink_disk_stats," which offers insights into partition names. The storage device details such as available space on disk, total size, etc can be viewed under Disk Stats. The stream corresponding to disk stats is "**uplink\_disk\_stats**" stream. This stream has the following fields: | Field | Description | | --------- | --------------------------------------------------------------- | | name | Name of the disk partition | | total | Total storage capacity of the partition in bytes. | | used | Disk space that is already occupied in the partition, in bytes. | | available | Disk space that is available in the partition, in bytes. | # Network Stats Source: https://bytebeam.io/docs/device-side-integrations/android/monitoring-your-device/network-stats Learn about the essential "**uplink\_network\_stats**" stream; discover how this document delineates crucial details like networking interface names, incoming and outgoing data rates. Network stats talk about the incoming and outgoing data rates of each networking interface. The "**uplink\_network\_stats**" stream has these details. This stream has the following fields: | Field name | Description | | -------------------- | ---------------------------------------------------------------- | | name | Name of the network interface. | | incoming\_data\_rate | The incoming data rate through the interface is in bytes/second. | | outgoing\_data\_rate | The outgoing data rate through the interface is in bytes/second. | # Process Stats Source: https://bytebeam.io/docs/device-side-integrations/android/monitoring-your-device/process-stats Learn how to view resource usage statistics of specific processes with this comprehensive guide. Discover how to specify process names in the config.toml file and access the uplink_process_stats stream. Explore the various fields available, such as PID, start_time, cpu_usage etc. Process stats allow you to monitor individual processes. To enable process stats we need to modify uplink's `config.toml` file to mention the process names that need monitoring. If you have followed the setup guide, this file should be present in `/usr/share/local/byebeam`. Add the below section to `config.toml` ```none theme={null} [system_stats] enabled = true process_names = ["uplink", "journalctl"] update_period = 30 ``` NOTE: The names of processes mentioned in the config should be the same as those in the output of `ps -eaf` The stream corresponding to process stats is **uplink\_process\_stats**. This stream has the below fields | Field name | Description | | ------------------------- | ------------------------------------------------------------------------------------------- | | pid | This field corresponds to a particular process's ID. | | start\_time | Time at which the process had started execution. | | cpu\_usage | Percentage of CPU being used by the process. | | mem\_usage | RAM is used by the process, in bytes. | | disk\_read\_bytes | The number of bytes of data read from the disk(or storage device) since the last update. | | disk\_total\_read\_bytes | Total number of bytes of data written to the disk(or storage device) since the last update. | | disk\_write\_bytes | A number of bytes of data read from the disk(or storage device) since the last update. | | disk\_total\_write\_bytes | Total number of bytes of data written to the disk(or storage device). | # Processor Stats Source: https://bytebeam.io/docs/device-side-integrations/android/monitoring-your-device/processor-stats Learn about processor stats and usage percentages in this informative document. Discover how the "uplink_processor_stats" stream conveys vital details such as CPU name, frequency, and overall usage percentage. Gain valuable insights into optimizing processor. Processor stats talk about the frequency at which each processor is running and the usage percentage of each processor. This data is pushed to the stream "**uplink\_processor\_stats**". This stream has the below field: | Field | Description | | --------- | ------------------------------------- | | name | Name of the CPU | | frequency | The clock frequency of the CPU in MHz | | usage | Percentage of CPU used | # System Stats Source: https://bytebeam.io/docs/device-side-integrations/android/monitoring-your-device/system-stats Learn about the valuable data provided by the "uplink_system_stats" stream, such as kernel version, running processes, device uptime, memory usage, and load averages. Enhance your understanding of system performance to optimize operations and improve efficiency. System stats contain information regarding the kernel version, memory usage, uptime, load average, etc. These details are pushed to the `uplink_system_stats` stream. This stream has the following fields: | Field name | Description | | ------------------ | ------------------------------------------------------- | | kernel\_version | The version of the currently running kernel. | | no\_processes | Count of the currently running processes in the system. | | uptime | Time elapsed in seconds since the device has booted. | | total\_memory | Total memory (RAM) present on the device in bytes | | used\_memory | Amount of memory being used by the device in bytes | | available\_memory | Memory available (unused) on the device in bytes | | load\_avg\_one | One-minute load average of the system | | load\_avg\_five | Five-minute load average of the system | | load\_avg\_fifteen | Fifteen-minute load average of the system | # Push application logs Source: https://bytebeam.io/docs/device-side-integrations/android/push-application-logs Learn how to effectively view journalctl logs on Bytebeam cloud with this comprehensive document. Discover the step-by-step instructions on setting up streams and dashboards, adding logging to devices, and configuring logging from the cloud. Detailed screrenshots are attached below. Using Bytebeam cloud, it is possible to view the logs of the device. Uplink is capable of collecting logcat logs and pushing them to cloud, which can then be visualized using the logs panel. You should create a stream called `logs` with this schema in your project: Now, we need to create a "**logs**" dashboard. # Create logs dashboard Go to the "**Dashboards**" section of Bytebeam Cloud and select "**Create Dashboard**" Give the title "**logs**" and select the Dashboard type as "**Device Dashboard**". Click on submit. The created dashboard should be visible now. Click on the "**logs**" dashboard and select the device for which you want to see the logs. Create a New Panel. Select the "Logs" panel. Give the appropriate title and select the "**Logs**" option from the "**Table**" drop-down menu. Click on submit. To enable the logging feature on the device, the following lines are to be added to the config.toml file. ```none theme={null} [logging] # logcat tags you want to upload tags = [ "AndroidContext", "io.bytebeam.android_web_wrapper.BluetoothService.R1", "io.bytebeam.android_web_wrapper.interfaces.WifiInterface", "BluetoothGatt" ] # 0 will collect all logs (VERBOSE) # 6 will collect only logs with priority "Fatal" min_level = 6 stream_size = 32 ``` Restart uplink. The logs should be visible on the cloud now. # Pushing data to Bytebeam Source: https://bytebeam.io/docs/device-side-integrations/android/pushing-data-to-bytebeam Learn how to push data to streams using ByteBeam Client with this comprehensive document. Includes a Rust code example for publishing data, emphasizing the need for JSON serialization. Discover the best practices, including omitting "id" and "timestamp" fields. You can use ByteBeam Client to push data to [Streams](https://bytebeamio.mintlify.app/platform-guide/streams-tables/introduction-to-streams). Follow [Creating a Stream](https://bytebeamio.mintlify.app/platform-guide/streams-tables/creating-a-stream) guide to create streams. ```rust theme={null} pub fn publish_to_stream( &self, // Bytebeam Client stream_name: &str, sequence: u32, payload: impl Serialize, ) -> anyhow::Result ``` Payload you want to publish must be something that can be Serialized to JSON. Lets say you have "**led\_status**" stream with field "**status**". You can create a struct and use **serde::Serialize** attribute. ```rust theme={null} #[derive(Serialize)] struct LedStream { // your custom fields! status: String, } fn main() { // .... let bytebeam_client = ByteBeamClient::init()?; let sequence = 1; let message = LedStream { status: "ON".into(), }; // You can remove .expect and handle the error bytebeam_client .publish_to_stream("led_status", sequence, message) .expect("published successfully"); //... } ``` *NOTE: Every stream has ****id**** and ****timestamp**** fields as well, we add them internally, so it is recommended to not include them in your custom struct!* \*\* # Receiving Actions Source: https://bytebeam.io/docs/device-side-integrations/android/receiving-actions Learn how to effectively use the actions feature of Bytebeam cloud on your Linux device with this comprehensive guide. Discover step-by-step instructions on creating a "reboot" action and gaining control over the uplink through essential commands. This guide shows you how to receive [Actions](/platform-guide/actions/action-details/introduction) (Commands) from the Cloud and execute them. Let us have a look at how to create a "reboot" action that restarts the device. To do this we need to first register this action with uplink using its configuration file `config.toml`. If you have followed the guide this file will be present in `/usr/local/share/bytebeam` folder. Edit this file to add the line actions=\[] under \[tcpapps.1] section. ```shell theme={null} persistence_path = "/data/local/tmp/uplink/persistence" action_redirections={update_firmware="install_firmware"} [tcpapps.1] port=5050 actions=[{name="reboot"}] [downloader] path="/data/local/tmp/uplink/downloads" actions=[{name="update_firmware", timeout=610}, {name="send_file"}] [apis] enabled=true port=3333 [ota_installer] path="/data/local/tmp/uplink/ota" actions=[{name="install_firmware", timeout=610}] uplink_port=5050 [logging] tags=["sshd", "systemd"] stream_size=1 min_level=7 ``` Restart the uplink using the following commands Create a new action type called "Reboot" by following the [Creating new Action Types](/platform-guide/actions/action-settings/creating-an-action-type) guide: The reboot action should now be visible on the device management page. Do not trigger the action yet. We need to first integrate the action into our application. Below you can find a sample application code for receiving actions. :::codeblocktabs ```python theme={null} import socket import json import time import os import threading s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) s.connect(("localhost", 5050)) # Converts JSON data received over TCP into a python dictionary def receive_action(s): return json.loads(s.recv(2048)) # Constructs a payload and sends it over TCP to uplink def send_data(s, payload): send = json.dumps(payload) + "\n" s.sendall(bytes(send, encoding="utf-8")) # Constructs a JSON `action_status` as a response to received action on completion def action_complete(id): return { "stream": "action_status", "sequence": 0, "timestamp": int(time.time() * 1000000), "action_id": id, "state": "Completed", "progress": 100, "errors": [], } # Reboots the device def reboot(action): payload = json.loads(action["payload"]) print(payload) resp = action_complete(action["action_id"]) print(resp) send_data(s, resp) os.system("sudo reboot") def receive_actions(): while True: action = receive_action(s) print(action) if action["name"] == "reboot": print("reboot action received") reboot(action) print("Starting Uplink Bridge App") threading.Thread(target=receive_actions).start() ``` ```javascript theme={null} const net = require("net"); const client = new net.Socket(); client.connect(5050, "localhost", () => { console.log("Connected to server"); }); // Converts JSON data received over TCP into a JavaScript object function receiveAction() { return new Promise((resolve, reject) => { client.once("data", (data) => { try { resolve(JSON.parse(data)); } catch (e) { reject(e); } }); }); } // Constructs a payload and sends it over TCP to uplink function sendData(payload) { const send = JSON.stringify(payload) + "\n"; client.write(send, "utf-8"); } // Constructs a JSON `action_status` as a response to received action on completion function actionComplete(id) { return { stream: "action_status", sequence: 0, timestamp: Date.now() * 1000, action_id: id, state: "Completed", progress: 100, errors: [], }; } // Reboots the device function reboot(action) { const payload = JSON.parse(action.payload); console.log(payload); const resp = actionComplete(action.action_id); console.log(resp); sendData(resp); exec("sudo reboot", (error, stdout, stderr) => { if (error) { console.error(`exec error: ${error}`); return; } console.log(`stdout: ${stdout}`); console.error(`stderr: ${stderr}`); }); } async function receiveActions() { while (true) { const action = await receiveAction(); console.log(action); if (action.name === "reboot") { console.log("reboot action received"); reboot(action); } } } console.log("Starting Uplink Bridge App"); receiveActions(); ``` ```rust theme={null} use serde_json::{json, Value}; use std::io::{Read, Write}; use std::net::TcpStream; use std::process::Command; use std::{thread, time}; fn main() { let mut stream = TcpStream::connect("localhost:5050").expect("Could not connect to server"); // Start a thread to receive actions let mut stream_clone = stream.try_clone().expect("Failed to clone stream"); thread::spawn(move || { receive_actions(&mut stream_clone); }); } fn receive_action(stream: &mut TcpStream) -> Value { let mut buffer = [0; 2048]; stream .read(&mut buffer) .expect("Failed to read from stream"); serde_json::from_slice(&buffer).expect("Failed to parse JSON") } fn send_data(stream: &mut TcpStream, payload: Value) { let send = payload.to_string() + "\n"; stream .write_all(send.as_bytes()) .expect("Failed to write to stream"); } fn action_complete(id: i64) -> Value { json!({ "stream": "action_status", "sequence": 0, "timestamp": time::SystemTime::now() .duration_since(time::UNIX_EPOCH) .expect("Time went backwards") .as_micros() as i64, "action_id": id, "state": "Completed", "progress": 100, "errors": [] }) } fn reboot(action: &Value) { let payload = &action["payload"]; println!("{:?}", payload); let resp = action_complete(action["action_id"].as_i64().unwrap()); println!("{:?}", resp); send_data(&mut stream, resp); Command::new("sudo") .arg("reboot") .output() .expect("failed to execute process"); } fn receive_actions(stream: &mut TcpStream) { loop { let action = receive_action(stream); println!("{:?}", action); if action["name"] == "reboot" { println!("reboot action received"); reboot(&action); } } } ``` ```go theme={null} package main import ( "encoding/json" "fmt" "net" "os" "os/exec" "strconv" "time" ) func main() { conn, err := net.Dial("tcp", "localhost:5050") if err != nil { fmt.Println("Error connecting:", err.Error()) os.Exit(1) } // Start a goroutine for receiving actions go receiveActions(conn) fmt.Println("Starting Uplink Bridge App") } // receiveAction reads and decodes JSON data from the connection func receiveAction(conn net.Conn) map[string]interface{} { buffer := make([]byte, 2048) length, _ := conn.Read(buffer) var data map[string]interface{} json.Unmarshal(buffer[:length], &data) return data } // sendData encodes the payload to JSON and sends it over the connection func sendData(conn net.Conn, payload map[string]interface{}) { send, _ := json.Marshal(payload) conn.Write(append(send, '\n')) } // actionComplete constructs a JSON action_status response func actionComplete(id interface{}) map[string]interface{} { return map[string]interface{}{ "stream": "action_status", "sequence": 0, "timestamp": time.Now().UnixNano() / int64(time.Microsecond), "action_id": id, "state": "Completed", "progress": 100, "errors": []string{}, } } // reboot performs a system reboot func reboot(action map[string]interface{}) { payload := action["payload"].(map[string]interface{}) fmt.Println(payload) resp := actionComplete(action["action_id"]) fmt.Println(resp) sendData(conn, resp) cmd := exec.Command("sudo", "reboot") cmd.Run() } // receiveActions listens for actions and processes them func receiveActions(conn net.Conn) { for { action := receiveAction(conn) fmt.Println(action) if action["name"] == "reboot" { fmt.Println("reboot action received") reboot(action) } } } ``` ::: Once your app has been modified and is running, you can go to Bytebeam Cloud and click on the Reboot action button to trigger the action. Next, you will see the following message Click on **Yes.** Next, on the action panel, you can monitor the status of your last triggered action After completion of an action, the *Action Status* changes to **Completed** and you should see your device reboot # Remote login to your Linux device Source: https://bytebeam.io/docs/device-side-integrations/android/remote-login-to-your-linux-device Learn how to access the Linux device shell via Bytebeam cloud using tunshell tool. Follow our guide to easily navigate to the Bytebeam cloud, select your preferred device, and effortlessly access the remote shell option under the Operations section. From the Bytebeam cloud, it is possible to access the shell on the Linux device. To shell into your device, go to the Bytebeam cloud, select the device, and under the "**Operations**" section click on the "**Remote** **Shell**" Button. You should now be able to see the shell environment on the cloud. Note that the shell will be started with the privileges given to the uplink service by the operating system. # Connecting to Bytebeam cloud Source: https://bytebeam.io/docs/device-side-integrations/custom/connecting-to-bytebeam-cloud Download the device TLS certificates from platform and use them to authorise with server. # Download the device auth json file We use TLS Mutual authentication to connect a device to the cloud. Mutual authentication means that both the server and the client authenticate each other before the connection is setup. Three files are required for this authentication to happen correctly 1. CA Certificate: This file is used by the device to authenticate the server certificate 2. Device Certificate: This file is used by the device to authenticate itself to the server 3. Device Private Key: This file is also used by the device to authenticate itself to the server. Bytebeam provides a single json file that contains the contents of these three files. You can download the json file by [Provisioning a Device](/platform-guide/device-management/provisioning-a-device). This should give you a file like the below: ```json theme={null} { "project_id": "demo", "broker": "cloud.bytebeam.io", "port": 8883, "device_id": "2", "authentication": { "ca_certificate": "-----BEGIN CERTIFICATE-----\nMIIFszCCA5ugAwIBAgIUEwLV4kBMkkaGFmddtLu7sms+/BMwDQYJKoZIhvcNAQEL\nBQAwYTELMAkGA1UEBhMCVE4xNzA1BgNVBAoMLkFnZW5jZSBOYXRpb25hbGUgZGUg\n<.. trimmed ..>u/2QeItBcy6vVR/cO5JyboTT0GFMDcx2V+IthSIVNg3rAZ3r2OvEhJn7wAzMMujj\nd9qDRIueVSjAi1jTkD5OGwDxFa2DK5o=\n-----END CERTIFICATE-----", "device_certificate": "-----BEGIN CERTIFICATE-----\nMIIEozCCBEmgAwIBAgIQTij3hrZsGjuULNLEDrdCpTAKBggqhkjOPQQDAjCBjzEL\nMAkGA1UEBhMCR0IxGzAZBgNVBAgTEkdyZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UE\n<.. trimmed ..>bTAKBggqhkjOPQQDAgNIADBFAiEAru2McPr0eNwcWNuDEY0a/rGzXRfRrm+6XfZe\nSzhYZewCIBq4TUEBCgapv7xvAtRKdVdi/b4m36Uyej1ggyJsiesA\n-----END CERTIFICATE-----", "device_private_key": "-----BEGIN RSA PRIVATE KEY-----\nMIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDNGprSdj+74i9/\n9lU+3d2XM4QIONUDKmqIuHRDxREGYcJg36kKeZc3S6iUH50oUSAYUyBSd8SyRmfa\n<.. trimmed ..>w85urMfh9z3Dq5xrNZJD+8TEDM/7Dz8meQj4n+oOIl8iHlKN9e7CTK4O3smS5/cN\n337I+FudGb8nO+Kv6PtsA6kD\n-----END RSA PRIVATE KEY-----" } } ``` **Note:** The certificates and keys in the above file and rest of this guide are just examples, you have to use the json file downloaded from the provisioning guide above. Let us extract the `ca_certificate`, `device_certificate` and `device_private_key` into three files. We will connect to Bytebeam cloud using these files and MQTTX. Note the "\n" characters in the strings. When extracting these into individual files we need to replace them with newlines. Here is how the three files would look like ```none CA Certificate theme={null} -----BEGIN CERTIFICATE----- MIIFszCCA5ugAwIBAgIUEwLV4kBMkkaGFmddtLu7sms+/BMwDQYJKoZIhvcNAQEL BQAwYTELMAkGA1UEBhMCVE4xNzA1BgNVBAoMLkFnZW5jZSBOYXRpb25hbGUgZGUg Q2VydGlmaWNhdGlvbiBFbGVjdHJvbmlxdWUxGTAXBgNVBAMMEFR1blRydXN0IFJv <...> nV2UqL1g52KAdoGDDIzMMEZJ4gzSqK/rYXHv5yJiqfdcZGyfFoxnNidF9Ql7v/YQ CvGwjVRDjAS6oz/v4jXH+XTgbzRB0L9zZVcg+ZtnemZoJE6AZb0QmQZZ8mWvuMZH u/2QeItBcy6vVR/cO5JyboTT0GFMDcx2V+IthSIVNg3rAZ3r2OvEhJn7wAzMMujj d9qDRIueVSjAi1jTkD5OGwDxFa2DK5o= -----END CERTIFICATE----- ``` ```none Device Certificate theme={null} -----BEGIN CERTIFICATE----- MIIEozCCBEmgAwIBAgIQTij3hrZsGjuULNLEDrdCpTAKBggqhkjOPQQDAjCBjzEL MAkGA1UEBhMCR0IxGzAZBgNVBAgTEkdyZWF0ZXIgTWFuY2hlc3RlcjEQMA4GA1UE BxMHU2FsZm9yZDEYMBYGA1UEChMPU2VjdGlnbyBMaW1pdGVkMTcwNQYDVQQDEy5T <...> uLBsCE8ktCUfvsiRT7zWSqeXliA09TUCIQDcB7Xn97aEDMBKXIbdm5KZ9GjvRyoF 9skD5/4GneoMWzAlBgNVHREEHjAcggpnaXRodWIuY29tgg53d3cuZ2l0aHViLmNv bTAKBggqhkjOPQQDAgNIADBFAiEAru2McPr0eNwcWNuDEY0a/rGzXRfRrm+6XfZe SzhYZewCIBq4TUEBCgapv7xvAtRKdVdi/b4m36Uyej1ggyJsiesA -----END CERTIFICATE----- ``` ```none Device Key theme={null} -----BEGIN RSA PRIVATE KEY----- MIIEvgIBADANBgkqhkiG9w0BAQEFAASCBKgwggSkAgEAAoIBAQDNGprSdj+74i9/ 9lU+3d2XM4QIONUDKmqIuHRDxREGYcJg36kKeZc3S6iUH50oUSAYUyBSd8SyRmfa shwTW0P2WA9kIccXbDlpWlbnRi7P/PrJ1pniDtgnJHJrhtvduPecyoS037nuYYRw <...> fyoQDuPjTuMBYKn0aj9JWfD4ohFRImcH1I3XcVkr0QKBgATjHK1sKXPNNnTD1MbL LJxhy5JmqY1pxwnO+XLEDMSNx3omrk7C2KmFUk2lg2NZM/2ZVnLmPvKKhV88df3C w85urMfh9z3Dq5xrNZJD+8TEDM/7Dz8meQj4n+oOIl8iHlKN9e7CTK4O3smS5/cN 337I+FudGb8nO+Kv6PtsA6kD -----END RSA PRIVATE KEY----- ``` # Connect using MQTTX Now open MQTTX and click on `+ New Connection` to create a new connection: Fill in the Name, Client ID, Host, Port as shown below. For the certificate field select "CA or self signed certificates" and upload the files we have extracted above. Select MQTT 3.1.1 as the protocol version in the advanced settings: Click on the Connect button on the top right and you should see a successful connection. Any errors need to be fixed before proceeding further with the guide. # Building this into your SDK Now that we have understood how to connect to bytebeam you can implement this programatically in your client. You can follow the below steps: 1. The first step towards building a client is figuring out how to implement MQTT. mqtt.org has a [list of client libraries for various operating systems and langauges.](https://mqtt.org/software/) If you are using a GSM modem in AT command mode it is possible that your modem comes built in with MQTT commands as well. 2. Note that bytebeam expects each device to present a unique MQTT client id. e.g. you can construct the client id as "client-\-\". 3. Once you have figured out an MQTT implementation, you can write code to connect using the certificates and private key downloaded from cloud. Note that we support only TLS 1.2 and above. Most modern systems support this version. 4. Make sure to handle disconnections and reconnect as required. # Implementing over the air updates Source: https://bytebeam.io/docs/device-side-integrations/custom/implementing-over-the-air-updates Receive and handle `update_firmware` action on device side which downloads the firmware and perform the update. Also publish the progress of OTA via the action status. Over the air updates is a special kind of action. Read the sections on [Creating a new Firmware Version](/platform-guide/actions/inventory-management/firmware-files/without-device-components/creating-a-new-firmware-version) and [Triggering OTA update](/platform-guide/device-management/triggering-ota-update) to learn how to upload a firmware file and push it to the device from the cloud. The payload for the OTA action `update_firmware` is as below: ```json theme={null} { "name": "update_firmware", "id": "3620755", "payload": "{\"content-length\":304,\"checksum\":null,\"status\":false,\"url\":\"https://firmware.cloud.bytebeam.io/api/v1/firmwares/v3.0.0/artifact\",\"version\":\"v3.0.0\"}", } ``` Notice that payload is json inside a string. Payload json has the following fields of interest: * `content-length`: The size of the firmware file * `url`: The url from which the firmware file needs to be downloaded * `version` The version of the file being downloaded Ignore the `checksum` and `status` fields. These fields are not implemented on cloud.bytebeam.io and are used by some of our enterprise clients The client needs to download the file at the url extracted from the payload above using https. Mutual TLS is implemented here as well i.e both the server and the client authenticate each other. The same certificates downloaded in the [Connect to Bytebeam cloud](/device-side-integrations/custom/connecting-to-bytebeam-cloud) section and used for settting up the MQTT connection need to be used here as well. # Implementing OTA in your client You can implement OTAs in your client as follows 1. As in the previous guide on [Receiving Actions](/device-side-integrations/custom/receiving-actions) subscribe to the actions topic 2. When an action with name `update_firmware` is received handle it as an OTA action: 1. Parse the payload as json 2. Extract the url field 3. Download the firmware using the certificates and private key from the json file downloaded earlier. Optionally send the download progress back to the cloud. 4. Implement the actual update. Send progress back during the update and at the end. It is useful to either have a factory version of the firmware or to store one previous version of the firmware to rollback in case the step 4 fails. In this case it is usefult to send the status as "Failed" and set the errors field to \["Rolled back to version xyz"] to the cloud. # Downloading the firmware file using curl We could not find a good GUI tool that supports custom certificates to show how to download the above files. However the curl command line tool is available for [different platforms](https://curl.se/download.html) and can be used for this purpose. Once curl has been installed you can run the below command to download the firmware file: ```shell theme={null} curl --cacert ./ca_certificate.pem --cert ./device_certificate.pem --key ./device_private_key.pem https://firmware.cloud.bytebeam.io/api/v1/firmwares/v3.0.0/artifact -o ./file.bin ``` In the above command replace `./ca_certificate.pem`, `./device_certificate.pem`, `./device_private_key.pem` and `./file.bin` with the full paths of these files on your system. # Pushing data to Bytebeam Source: https://bytebeam.io/docs/device-side-integrations/custom/pushing-data-to-bytebeam Publish data to `/tenants/{tenant_id}/devices/{device_id}/events/{stream_name}/jsonarray` in JSON array format. # Introduction The previous section shown us how to connect to bytebeam. It is now time to start pushing some data. All communication with Bytebeam happens using JSON. On Bytebeam data is organised into [Streams](https://bytebeamio.mintlify.app/platform-guide/streams-tables/introduction-to-streams). Each stream is mapped to an MQTT topic. Go through the [Creating a Stream](https://bytebeamio.mintlify.app/platform-guide/streams-tables/creating-a-stream) guide to create a stream. Every project in bytebeam comes with a default stream called [Device Shadow](https://bytebeamio.mintlify.app/getting-started/device-shadow). We will be illustring how to push data using this stream. # MQTT topic and payload structure ### Topic structure To push data to any stream, you need to publish data to the MQTT topic: `/tenants/{tenant_id}/devices/{device_id}/events/{stream_name}/jsonarray` Replace `{tenant_id}` with your project name and `{device_id}` with the device id. You can find these in the JSON file downloaded in the previous section. Say we are on `demo` project and device id is `1`, so in our case, topic for device shadow will be: `/tenants/demo/devices/1/events/device_shadow/jsonarray` Data should be published with QoS 0 or 1 only, QoS 2 is not supported yet. ### Payload The payload must be a jsonarray, which is an array of data point, where data point is just a JSON object with following fields: * `sequence`: an auto incrementing number for each packet * `timestamp`: Timestamp in milliseconds * other fields of the stream ( note: Field names are case sensitive ) so example of a payload for our device\_shadow which contains field `Status` will look like: ```json theme={null} [ { "sequence": 1, "timestamp": 1710760059006, "Status": "On" } ] ``` *A device should only publish data to the tenant it is connected*.
**\_Device will be disconnected** if device connected to tenant `demo`, tries to publish to other tenant, say `mytenant`, e.g. `/tenants/mytenant/devices/1/events/device_shadow/jsonarray`
### Batching Data As the payload that server accepts is a JSON array. If your client is expected to generate a large amount of data it will be more efficient to batch data and send it to the cloud instead of sending a single packet with each message. For example: ```json theme={null} [ { "sequence": 1, "timestamp": 1710760059006, ... }, { "sequence":2, "timestamp": 1710775681047, ... } ] ``` ### Compressing Data If you are sending larger batches of data you can save on data size by sending `zlib` or `lz4` compressed data. zlib compressed data for stream should be published to: ``` /tenants/{tenant_id}/devices/{device_id}/events/{stream_name}/jsonarray/zlibdeflate ``` ( Notice the `zlibdeflate` at end of topic ) LZ4 compressed data for stream should be published to: ``` /tenants/{tenant_id}/devices/{device_id}/events/{stream_name}/jsonarray/lz4 ``` ( Notice the `lz4` at end of topic ) Data must be compressed in **LZ4 Frame** format! You can verify it by magic bytes, i.e. the initial bytes of compressed data, they shoud be `04 22 4d 18` # Trying it out with MQTTX You can try publishing data using MQTTX as shown below. Notice the QoS1 setting: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/A-L1Vb_lX8_oILcPVSEK9_image.png) You should see the Status change on Bytebeam now: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/Se5Rryvfhu3wCt6pkjxZH_image.png) # Receiving Actions Source: https://bytebeam.io/docs/device-side-integrations/custom/receiving-actions Subscribe to `/tenants/{tenant_id}/devices/{device_id}/actions` to receive actions and publish the reponse to `/tenants/{tenant_id}/devices/{device_id}/action/status` in JSON array format. # Introduction To trigger an action from the cloud follow the guides on [Creating new Action Types](/platform-guide/actions/action-settings/creating-an-action-type) and [Triggering an Action](/platform-guide/device-management/triggering-ota-update). Let us assume an action called `print` has been created that prints the payload: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/JkWw-TjfFURxcD0qSt-Qa_image.png) ### Receiving Action [Actions](/platform-guide/actions/action-details/introduction) or commands can be received from Bytebeam by **subscribing** to the actions MQTT topic: ``` /tenants/{tenant_id}/devices/{device_id}/actions ``` Replace `{tenant_id}` with your project name and `{device_id}` with the device id. *A device should only subscribe to the topic with tenant it is connected*.
**\_Device will be disconnected** if device connected to tenant `demo`, tries to subscribe to topic with other tenant, say `mytenant`, e.g. `/tenants/mytenant/devices/1/actions`
Once the action is triggered you will receive a message on MQTT: ```json theme={null} { "id": "3620695", "name": "print", "payload": "Hello World!", } ``` here: * `id`: An unique identifier generated for this event which will be used to ack back. * `name`: Name of the action that is triggered * `payload`: Optional payload that is provided while triggering the action ### Responding to Action with Action Status We need to send a response back to the cloud to indicate progress of executing the command. This response must be published to: ``` /tenants/{tenant_id}/devices/{device_id}/action/status ``` And the payload should look like this: ```json theme={null} [   {     "action_id": "3620695",     "timestamp": 1710774583249, "sequence": 123,     "state": "Completed",     "errors": [],     "progress": 100   } ] ``` In the above action response: * `id`: Must be a string and the same `id` which was received with action * `timestamp`: Timestamp in milliseconds * `state`: can be any text to indicuate current status. e.g. A long running commands, like OTA, might have multiple states "Downloading", "Updating ECU 1", "Updating ECU 2" so on so forth as statuses. `"Failed"` and `"Completed"` are special terminal states that indicate that the action is complete * `errors`: is an array of strings and is looked at *only if the `state` is sent as `"Failed"`*. The UI displays these errors. e.g. `["File not found"]` * `progress`: Percentage in range 0 to 100 indicating progress within a given state. e.g. if `state` is "Downloading" and `progress` is 50 it means 50% of Downlaod is complete. `progress` is ***ignored*** if `state` is `"Completed"` or `"Failed"` For long running actions, periodically send the action status. Sending action status as `"Received"` to notify the server that the action is received is optional but a good practice. Send `"Completed"` or `"Failed"` status at the end of the action. # Receiving actions using MQTTX Open MQTTX and click on the `+ New Subscription` button: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/ouvtBHkW3DfPgk560M2ip_image.png) Enter the topic (Replace tenant and device\_id) and set QoS to 1: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/MzOP8-VouiWP6MY1kG9fO_image.png) Hit confirm. You should see the subscription now: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/57F304TNFHyYHM271I2Tw_image.png) From the device management screen on your project trigger the print command: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/tWTrnsJqiqpnmBYVnJcOL_image.png) This will open up a dialog as shown below. Enter payload and click on "Yes": ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/BPuooOcYD_9ou4OyLf_R1_image.png) You will see the action get created with status as "Initiated" ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/waWofel1eKSFmxKYIOENp_image.png) On MQTTX you should now receive a message like below: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/trU6Hkle9xBdjMJKqKLa__image.png) Notice the id in the payload matches the id on the you see on the UI. Ignore the additional field `kind`. That field has been deprecated. You can send progress back as shown below: ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/RN7s2Pxykh1A5zAKfev4v_image.png) Do not forget to set the id to what was received in the message by you and also change `demo` and device id `2` to your tenant and device id You should now be able to see the action as completed on the UI ![](https://archbee-image-uploads.s3.amazonaws.com/KgoQSkw-NkQJykt01OVJo/FjDADa7i3iaPRVcebCdYZ_image.png) # Connect to Bytebeam cloud Source: https://bytebeam.io/docs/device-side-integrations/linux/connect-to-bytebeam-cloud Learn how to connect your device to the Bytebeam cloud with this step-by-step guide. Start by creating an account on Bytebeam, then download the device configuration JSON file. Rename the file to "device.json" and store it in the "download" partition of your device. This page assumes that you have gone through the [Getting Started guide](https://bytebeamio.mintlify.app/getting-started/signup) for creating an account. # Provisioning the device Each device needs to be provisioned with a unique JSON file `device.json` that is used for authentication. Refer to the [Device Provisioning Guide](https://bytebeamio.mintlify.app/platform-guide/device-management/provisioning-a-device) to download the device configuration file. Rename the downloaded file to device.json and place it in the "download" partition(/mnt/download) of the device. If you are connecting to the device via ssh you can use the below `scp` command. First, provide permission to the /mnt/download partition using `chmod` command. ```shell theme={null} chmod 777 /mnt/download ``` and then use `scp` command ```shell theme={null} scp /home/bytebeam/Downloads/device.json user@:/mnt/download ``` # Running Uplink Start uplink and enable it to run at boot. ```shell theme={null} sudo systemctl start uplink sudo systemctl enable uplink ``` To verify that the uplink is up and running, check the status in systemd, using the following command. ```shell theme={null} sudo systemctl status uplink ``` You should see the status as "active" like in the screenshot below: # Customising device shadow Source: https://bytebeam.io/docs/device-side-integrations/linux/customising-device-shadow Learn about streams and device shadows in client applications with this document. Discover how default parameters like timestamp and sequence number are pushed to the device shadow stream. Explore the possibility of creating custom device shadow streams with the instructions below. Every project in Bytebeam comes with a default [Device Shadow](https://bytebeamio.mintlify.app/getting-started/device-shadow) stream. The stream by default contains just three fields `Status`, `timestamp`, and `sequence`. This guide shows how to create additional fields and write data to this stream from your application. For that, Click on the **username** at the top right corner of the Bytebeam  cloud console and navigate to **Settings**  Here under the **Stream** Tab, you can find “**device\_shadow**” For example, add two new columns `device_name` and `arch` to the device shadow. You can do this by entering the field name and type and clicking the + button. After adding both fields your device shadow will look like the below: Now update your application to push this data to the device. :::codeblocktabs ```python theme={null} import socket import json import time s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) s.connect(("localhost", 5050)) # Constructs a payload and sends it over TCP to uplink def send_data(s, payload): send = json.dumps(payload) + "\n" s.sendall(bytes(send, encoding="utf-8")) # Add more parameters to device shadow def send_device_shadow(s, sequence): timestamp = int(time.time() * 1000) payload = { "stream": "device_shadow", "sequence": sequence, "timestamp": timestamp, "device_name": "Beaglebone Black Rev. C", "arch": "armv7", } print(payload) send_data(s, payload) print("Starting Uplink Bridge App") sequence = 1 while True: time.sleep(10) send_device_shadow(s, sequence) sequence += 1 ``` ```javascript theme={null} const net = require("net"); // Connect to the server const client = new net.Socket(); client.connect(5050, "localhost", () => { console.log("Connected to server"); }); // Constructs a payload and sends it over TCP to uplink function sendData(payload) { const send = JSON.stringify(payload) + "\n"; client.write(send); } // Send device shadow data function sendDeviceShadow(sequence) { let timestamp = Date.now(); let payload = { stream: "device_shadow", sequence: sequence, timestamp: timestamp, device_name: "Beaglebone Black Rev. C", arch: "armv7", }; console.log(payload); sendData(payload); } console.log("Starting Uplink Bridge App"); let sequence = 1; setInterval(() => { sendDeviceShadow(sequence); sequence++; }, 10000); ``` ```rust theme={null} use std::net::TcpStream; use std::io::{Read, Write}; use std::thread; use std::time::{Duration, SystemTime}; use serde_json::{Value, json}; async fn send_data(mut stream: &TcpStream, payload: serde_json::Value) { let send = format!("{}\n", payload.to_string()); stream.write_all(send.as_bytes()).await.unwrap(); } async fn send_device_shadow(mut stream: &TcpStream, sequence: u64) { let timestamp = SystemTime::now() .duration_since(SystemTime::UNIX_EPOCH) .unwrap() .as_millis(); let payload = json!({ "stream": "device_shadow", "sequence": sequence, "timestamp": timestamp, "device_name": "Beaglebone Black Rev. C", "arch": "armv7" }); println!("{:?}", payload); send_data(&mut stream, payload).await; } #[tokio::main] async fn main() { let addr = "localhost:5050"; let mut stream = TcpStream::connect(&addr).await.unwrap(); println!("Starting Uplink Bridge App"); let mut sequence = 1; loop { thread::sleep(Duration::from_secs(5)); send_device_shadow(&mut stream, sequence); sequence += 1; } } ``` ```go theme={null} package main import ( "encoding/json" "fmt" "net" "os" "strconv" "time" ) // DeviceShadow represents the payload structure type DeviceShadow struct { Stream string `json:"stream"` Sequence int `json:"sequence"` Timestamp int64 `json:"timestamp"` DeviceName string `json:"device_name"` Arch string `json:"arch"` } func sendData(conn net.Conn, payload interface{}) { data, _ := json.Marshal(payload) fmt.Println(string(data)) conn.Write(append(data, '\n')) } // sendDeviceShadow constructs and sends a device shadow payload func sendDeviceShadow(conn net.Conn, sequence int) { t := time.Now().UnixNano() / int64(time.Millisecond) payload := DeviceShadow{ Stream: "device_shadow", Sequence: sequence, Timestamp: t, DeviceName: "Beaglebone Black Rev. C", Arch: "armv7", } fmt.Println(payload) sendData(conn, payload)(conn, payload) } func main() { conn, err := net.Dial("tcp", "localhost:5050") if err != nil { fmt.Println("Error connecting:", err.Error()) os.Exit(1) } defer conn.Close() fmt.Println("Starting Uplink Bridge App") sequence := 1 for { time.Sleep(5 * time.Second) sendDeviceShadow(conn, sequence) sequence++ } } ``` ::: You should now be able to see the new fields on Bytebeam cloud: # BeagleBone Black Source: https://bytebeam.io/docs/device-side-integrations/linux/device-setup/beaglebone-black Learn how to set up a BeagleBone Black device using this comprehensive document. From flashing the ByteBeam BeagleBoneBlack image onto the SD card to accessing the device via UART, this guide covers it all. Get the step-by-step instructions below. # Selecting the OS This section explains how to do an initial setup, for an off-the-shelf BeagleBone Black. To get started, the following things are needed. 1. BeagleBoneBlack development kit. 2. An SD Card (of size 64GB). 3. An adapter for power supply (with at least 15W of power) 4. ByteBeam BeagleBoneBlack image ByteBeam BeagleBone image can be downloaded from this link. Install the balena etcher software by following the instructions in this link. Once the installation is done, plug in the SD card into the system and launch balena-etcher software. Follow these steps to flash the Bytebeam BeagleBone image to the SD Card. **Select the Flash from file option in balena-ecther** **Select Bytebeam BeagleBone image** **Select the appropriate SD Card and flash the image.** # Partition Schema The SD Card is now setup to contain 4 partitions. 1. Partition 1 - Boot partition (/dev/mmcblk0p1) 2. Partition 2 - Root partition 1  (/dev/mmcblk0p2) 3. Partition 3 - Root partition 2 (/dev/mmcblk0p3) 4. Partition 4 - download partition (/dev/mmcblk0p4) At any given point in time either "Partition 2" or "Partition 3" will be the active rootfs partition, and the other partition is referred to as the inactive partition. The download partition is where the persistent files are stored. During kernel & rootfs updates, the contents of inactive partitions are replaced with the new rootfs. # Booting BeagleBone Once the flashing is complete, insert the SD card into the BeagleBone. Push and hold the boot button(S2) on the BeagleBone dev. kit and power on the board. This ensures that the device boots from the SD Card and not from the onboard eMMC. Refer to this [link](https://subscription.packtpub.com/book/iot-and-hardware/9781785285059/1/ch01lvl1sec14/booting-your-beaglebone-board-from-a-sd-card) for a detailed description of this process. In order to flash the eMMC with the contents of the SD card: **Step 1:** Uncomment the following line from uEnv.txt in the boot partition. ```shell theme={null} cmdline=init=/opt/scripts/tools/eMMC/init-eMMC-flasher-v3.sh ``` **Step 2:** Push and hold the boot button(S2) on the BeagleBone dev. kit and power on the board. This process generally 30 to 40 minutes. This "[Getting Started](https://docs.beagleboard.org/latest/boards/beaglebone/black/ch03.html#connect-the-cable-to-the-board)" guide talks about different ways of accessing the BeagleBone from the Laptop/PC. It is also possible to access the BeagleBone via UART. Refer to [this](https://www.dummies.com/article/technology/computers/hardware/beaglebone/how-to-connect-the-beaglebone-black-via-serial-over-usb-144981/) link for details on connecting BeagleBone to the system via UART. # Download the one-time setup scripts Once the BeagleBone is up, run the below one-time setup script. This script installs Bytebeam's Linux agent [uplink](https://github.com/bytebeamio/uplink) as well as scripts required for over-the-air updates ```shell theme={null} curl --proto '=https' --tlsv1.2 -sSf https://raw.githubusercontent.com/bytebeamio/uplink/main/scripts//one_time_setup.sh | bash ``` # Linux Generic Source: https://bytebeam.io/docs/device-side-integrations/linux/device-setup/linux-generic Learn how to efficiently integrate uboot as the bootloader for your device with this comprehensive document. From partition schema creation to switching logic implementation, this guide covers it all. Discover the steps to generate the boot.scr file, download uplink binary and setup scripts. # Overview This guide shows how to setup a generic Linux device to connect to Bytebeam. We assume you are using u-boot for the bootloader. If you are using a different bootloader please get in touch with us at [support@bytebeam.io](mailto:support@bytebeam.io) and we would be happy to guide you through the process. # Partition Schema Create the following partitions on the device Partition 1 - Boot partition of size around 100MB. Partition 2 - Root partition 1 (contains rootfs of Linux distro). Partition 3 - Root partition 2 (of size same as Root partition 1). Partition 4 - Download partition (to store application data) At any given point in time either "Partition 2" or "Partition 3" will be the active rootfs partition, and the other partition is referred to as the inactive partition. Data/Download partition is where the persistent files are stored. During kernel & rootfs updates, the contents of inactive partitions are replaced with the new rootfs. To begin with setup your existing rootfs into root partition 1 and point u-boot to boot into this partition. Once you have booted into partition 1: 1. Mount the boot partition at /uboot. 2. Mount the root partition 2 at /mnt/next\_root. 3. Mount the download partition 2 at /mnt/download. # Customizing u-boot for OTAs Bytebeam uses uboot as the bootloader in order to support rollback feature, during rootfs updates. U-boot can be configured with the help of a boot script called boot.scr. ## Root Switch Logic This section explains the workings of u-boot for choosing the right partition to boot from. Understanding this section is required to be able to troubleshoot any issues you may face. At a high level, we configure u-boot to look for a specific file in the boot partition to know which partition to boot form. For example, if file "two" is present, uboot boots from partition 2, and if file "three" is present, uboot boots from partition 3. The following flowchart explains the Root Switch logic in detail. ## Generate boot.scr The above logic needs to be implemented in the boot.scr file. Follow the below steps: **Step 1:** Download the [u-boot](https://github.com/u-boot/u-boot) source code. **Step 2:** Create the config. file named boot-cmd.txt. With the help of the "Root Switch" logic in this file, uboot can boot to the desired root partition. Note that this file depends on the type of the Linux device. Example files(uEnv.txt, rpi-boot-cmd.txt) are provied in the [Github](https://github.com/bytebeamio/uplink/tree/main/scripts) page. **Step 3:** From the config. file, boot script file boot.scr can be generated by: ```shell theme={null} cd /path/to/uboot u-boot/tools/mkimage -A arm64 -O linux -T script -C none -d boot-cmd.txt boot.scr ``` **Step 4:** Place the u-boot binary and boot script in the boot partition of the device. **Step 5:** Ensure that the fstab has the proper partition configuration. # Setup uplink and OTA scripts **Step 1:** Depending on the architecture of the device, the appropriate uplink binary can be downloaded from [this](https://github.com/bytebeamio/uplink/releases) link. Place it in the download partition, rename the binary as uplink, and make it executable. **Step 2:** Download the setup scripts ```shell theme={null} # get uplink.service curl --proto '=https' --tlsv1.2 -sSf -o /mnt/download/systemd/uplink.service https://raw.githubusercontent.com/bytebeamio/uplink/main/scripts/systemd/uplink.service # get check-root-partition.service curl --proto '=https' --tlsv1.2 -sSf -o /mnt/download/systemd/check-root-partition.service https://raw.githubusercontent.com/bytebeamio/uplink/main/scripts/systemd/check-root-partition.service # get config.toml curl --proto '=https' --tlsv1.2 -sSf -o /usr/local/share/bytebeam/config.toml https://raw.githubusercontent.com/bytebeamio/uplink/main/scripts/config.toml # get check_root_part.sh curl --proto '=https' --tlsv1.2 -sSf -o /mnt/download/check_root_part.sh https://raw.githubusercontent.com/bytebeamio/uplink/main/scripts/check_root_part.sh chmod +x /mnt/download/check_root_part.sh ``` **Step 3:** Add services to systemd ```shell theme={null} cp /mnt/download/systemd/uplink.service /etc/systemd/system/ cp /mnt/download/systemd/check-root-partition.service /etc/systemd/system/ systemctl daemon-reload systemctl enable check-root-partition.service systemctl start check-root-partition.service ``` **Step 4:** Depending on the root partition, create the file "two" or "three" in the boot partition and in the download partition as well. ```shell theme={null} BOOT=/uboot touch $BOOT/two touch /mnt/download/two ``` **Step 5:** Install vim and netcat ```shell theme={null} sudo apt update sudo apt install vim -y sudo apt install netcat -y ``` Boot the device. Ensure that the device has a good internet connection and that the system time is set properly. # Raspberry Pi Source: https://bytebeam.io/docs/device-side-integrations/linux/device-setup/raspberry-pi Learn how to set up a Raspberry Pi with this step-by-step document. Find out which components you need and how to install the rpi-imager software to select the operating system for your Pi. Get instructions on flashing the image to the SD card, setting up partition schema. # Selecting the OS This section explains how to do an initial setup, for an off-the-shelf Raspberry Pi. To get started, the following things are needed. 1. Raspberry Pi Board (In this example we use Raspberry Pi Model 3B+). 2. An SD Card (of size 64GB) 3. An adapter for power supply (with at least 15W of power) 4. ByteBeam RPI image ByteBeam RPI image can be downloaded from [this](https://drive.google.com/file/d/1fdH88IS-wuUvqT6SPsIt7Vmy3tzezECW/view?usp=sharing) link. Install the RPI-imager software by following the instructions in [this](https://www.raspberrypi.com/software/) link. Once the installation is done, connect the SD card to the Linux machine and launch the RPI-imager software. To do so, simply type in rpi-imager on the terminal. ```shell theme={null} sudo rpi-imager ``` Then click on Choose OS. A new window will open up, that has the list of all available Operating Systems for the Raspberry Pi. Select the Custom Image option. Select the downloaded ByteBeam RPI image. # Flashing the image to the SD Card Using RPI-imager, it’s possible to enable SSH, set a username and password for the Pi, and also input the WiFi credentials. Click on the settings icon on the rpi-imager GUI. Setup the necessary configurations. Save the configuration and click on Write, for the image to be flashed on the SD Card. # Partition Schema The SD Card is now setup to contain 4 partitions. 1. Partition 1 - Boot partition (/dev/mmcblk0p1) 2. Partition 2 - Root partition 1  (/dev/mmcblk0p2) 3. Partition 3 - Root partition 2 (/dev/mmcblk0p3) 4. Partition 4 - Download partition (/dev/mmcblk0p4) At any given point in time either "Partition 2" or "Partition 3" will be the active rootfs partition, and the other partition is referred to as the inactive partition. The download partition is where application data is stored. During kernel & rootfs updates, the contents of inactive partitions are replaced with the new rootfs. Once the flashing is complete, insert the SD card into the Pi and power on the Pi. If everything is alright, the Pi can be accessed either through SSH or via UART. Refer to [this](https://emteria.com/kb/connect-uart-rpi) link on how to connect the Pi to the system via UART. # SDK Setup Once the Pi is up run the below one-time setup script. This script installs Bytebeam's Linux agent [uplink](https://github.com/bytebeamio/uplink) as well as scripts required for over-the-air updates *** ```shell theme={null} sudo curl --proto '=https' --tlsv1.2 -sSf https://raw.githubusercontent.com/bytebeamio/uplink/main/scripts/one_time_setup.sh | sudo bash ``` # Integrate Config Updates Source: https://bytebeam.io/docs/device-side-integrations/linux/integrate-config-updates Learn how to update the configuration of your device using Bytebeam cloud with this comprehensive guide. Follow the step-by-step instructions to access the device management section, create a new device config, and confirm your selection. Bytebeam enables you to remotely change the configuration of your application. This is done by sending JSON-based configuration to the device. This guide will walk you through how to achieve this. # Creating new device config. Steps to update configuration: **Step 1**: Go to the device management section in Bytebeam cloud. **Step 2**: Go to the "Device Configs" section **Step 3**: Click on "New Device Config" **Step 4**: Enter the appropriate details for the device configuration. In this example, We are changing the current log level of our Python application The new device config should be visible now. On the device, First, register this action with uplink using its configuration file **config.toml** as we did in the [Receiving Actions](https://bytebeamio.mintlify.app/device-side-integrations/linux/receiving-actions) section. This file is present in **/usr/local/share/bytebeam** folder. Edit this file to add the line **actions=\[]** under **\[tcpapps.1]** section. ```shell theme={null} persistence_path = "/tmp/uplink" action_redirections={update_firmware="install_firmware"} [tcpapps.1] port=5050 actions=[{name="reboot"}, {name="update_config"}] [downloader] path="/tmp/uplink/download" actions=[{name="update_firmware", timeout=610}, {name="send_file"}] [apis] enabled=true port=3333 [ota_installer] path="/tmp/uplink/installer" actions=[{name="install_firmware", timeout=610}] uplink_port=5050 [logging] tags=["sshd", "systemd"] stream_size=1 min_level=7 ``` Restart the uplink using the following commands ```shell theme={null} sudo systemctl restart uplink ``` Next using the following example you can update the configuration on your device :::codeblocktabs ```python theme={null} import socket import json import time import threading import logging s = socket.socket(socket.AF_INET, socket.SOCK_STREAM) s.connect(("localhost", 5050)) # Converts JSON data received over TCP into a python dictionary def receive_action(s): return json.loads(s.recv(2048)) # Constructs a payload and sends it over TCP to uplink def send_data(s, payload): send = json.dumps(payload) + "\n" s.sendall(bytes(send, encoding="utf-8")) # Constructs a JSON `action_status` as a response to received action on completion def action_complete(id): return { "stream": "action_status", "sequence": 0, "timestamp": int(time.time() * 1000000), "action_id": id, "state": "Completed", "progress": 100, "errors": [], } def update_config(action): payload = json.loads(action["payload"]) print(payload) app = payload["name"] print(app) level = payload["level"] if app == "logging": set_log_level(level) resp = action_complete(action["action_id"]) print(resp) send_data(s, resp) def receive_actions(): while True: action = receive_action(s) print(action) if action["name"] == "update_config": print("update_config action received") print(json.loads(action["payload"])) update_config(action) def set_log_level(level): if level.lower() == "info": logging.getLogger().setLevel(logging.INFO) elif level.lower() == "error": logging.getLogger().setLevel(logging.ERROR) elif level.lower() == "verbose": logging.getLogger().setLevel(logging.VERBOSE) elif level.lower() == "debug": logging.getLogger().setLevel(logging.DEBUG) print("Starting Uplink Bridge App") threading.Thread(target=receive_actions).start() logging.getLogger().setLevel(logging.INFO) logging.Formatter("%(levelname)s - %(message)s") while True: time.sleep(5) logging.debug("This is debug") logging.info("This is info") ``` ```javascript theme={null} const logger = log4js.getLogger(); const net = require("net"); const log4js = require("log4js"); const client = new net.Socket(); client.connect(5050, "localhost", () => { console.log("Connected to server"); }); // Configure logger log4js.configure({ appenders: { console: { type: "console" } }, categories: { default: { appenders: ["console"], level: "info" } }, }); // Receive JSON data over TCP function receiveAction(socket) { return new Promise((resolve, reject) => { socket.once("data", (data) => { try { const action = JSON.parse(data.toString()); resolve(action); } catch (error) { reject(error); } }); }); } // Send JSON payload over TCP function sendData(socket, payload) { const send = JSON.stringify(payload) + "\n"; socket.write(send); } // Construct and send action status function actionComplete(id) { return { stream: "action_status", sequence: 0, timestamp: Date.now(), action_id: id, state: "Completed", progress: 100, errors: [], }; } async function updateConfig(action) { const payload = JSON.parse(action.payload); console.log(payload); const app = payload.name; console.log(app); const level = payload.level; if (app === "logging") { setLogLevel(level); } const resp = actionComplete(action.action_id); console.log(resp); sendData(client, resp); } // Receiving actions async function receiveActions() { while (true) { const action = await receiveAction(client); console.log(action); if (action.name === "update_config") { console.log("update_config action received"); console.log(JSON.parse(action.payload)); await updateConfig(action); } } } console.log("Starting Uplink Bridge App"); receiveActions(); // Log messages at intervals setInterval(() => { logger.debug("This is debug"); logger.info("This is info"); }, 5000); ``` ```rust theme={null} use chrono::Utc; use flexi_logger::{LevelFilter, LogSpecification, Logger}; use log::{debug, error, info}; use serde_json::json; use std::io::{BufRead, BufReader, Write}; use std::net::TcpStream; use std::thread; fn receive_action(stream: &mut TcpStream) -> serde_json::Result { let mut reader = BufReader::new(stream); let mut buffer = String::new(); reader.read_line(&mut buffer)?; serde_json::from_str(&buffer) } fn send_data(stream: &mut TcpStream, payload: serde_json::Value) { let serialized = serde_json::to_string(&payload).unwrap() + "\n"; stream.write_all(serialized.as_bytes()).unwrap(); } fn action_complete(action_id: &str) -> serde_json::Value { json!({ "stream": "action_status", "sequence": 0, "timestamp": Utc::now().timestamp_millis(), "action_id": action_id, "state": "Completed", "progress": 100, "errors": [] }) } fn update_config(stream: &mut TcpStream, action: &serde_json::Value) { let payload: serde_json::Value = serde_json::from_str(action["payload"].as_str().unwrap()).unwrap(); let app = payload["name"].as_str().unwrap(); let level = payload["level"].as_str().unwrap(); if app == "logging" { set_log_level(level); } let resp = action_complete(action["action_id"].as_str().unwrap()); send_data(stream, resp); } fn set_log_level(level: &str) { let level_filter = match level.to_lowercase().as_str() { "info" => LevelFilter::Info, "error" => LevelFilter::Error, "verbose" => LevelFilter::Trace, // Rust doesn't have 'verbose', using 'Trace' instead "debug" => LevelFilter::Debug, _ => LevelFilter::Info, }; let log_spec = LogSpecification::default().with_default(level_filter); Logger::with(log_spec).start().unwrap_or_else(|e| { eprintln!("Failed to initialize logger: {}", e); }); info!("Log level set to {}", level); } fn receive_actions(mut stream: TcpStream) { loop { let action = receive_action(&mut stream).unwrap(); if action["name"] == "update_config" { update_config(&mut stream, &action); } } } fn main() { Logger::with_env_or_str("info").start().unwrap(); let mut stream = TcpStream::connect("localhost:5050").unwrap(); println!("Starting Uplink Bridge App"); let stream_clone = stream.try_clone().unwrap(); thread::spawn(move || { receive_actions(stream_clone); }); loop { thread::sleep(std::time::Duration::from_secs(5)); debug!("This is debug"); info!("This is info"); error!("This is error"); } } ``` ```go theme={null} package main import ( "bufio" "encoding/json" "fmt" "io" "net" "os" "time" log "github.com/sirupsen/logrus" ) func main() { conn, err := net.Dial("tcp", "localhost:5050") if err != nil { fmt.Println("Error connecting:", err) os.Exit(1) } defer conn.Close() log.SetLevel(log.InfoLevel) log.SetFormatter(&log.TextFormatter{}) log.SetOutput(os.Stdout) go receiveActions(conn) fmt.Println("Starting Uplink Bridge App") for { time.Sleep(5 * time.Second) log.Debug("This is debug") log.Info("This is info") log.Error("This is error") } } // receiveAction reads and decodes a JSON message from the connection. func receiveAction(conn net.Conn) (map[string]interface{}, error) { reader := bufio.NewReader(conn) msg, err := reader.ReadString('\n') if err != nil { return nil, err } var action map[string]interface{} err = json.Unmarshal([]byte(msg), &action) return action, err } // sendAction encodes a payload as JSON and sends it over the connection. func sendAction(conn net.Conn, payload map[string]interface{}) error { msg, err := json.Marshal(payload) if err != nil { return err } _, err = conn.Write(append(msg, '\n')) return err } // actionComplete constructs a JSON `action_status` as a response to received action on completion. func actionComplete(id interface{}) map[string]interface{} { return map[string]interface{}{ "stream": "action_status", "sequence": 0, "timestamp": time.Now().UnixNano() / 1000, "action_id": id, "state": "Completed", "progress": 100, "errors": []string{}, } } // updateConfig processes the update_config action. func updateConfig(conn net.Conn, action map[string]interface{}) { payloadStr := action["payload"].(string) var payload map[string]interface{} json.Unmarshal([]byte(payloadStr), &payload) app := payload["name"].(string) level := payload["level"].(string) if app == "logging" { setLogLevel(level) } resp := actionComplete(action["action_id"]) sendAction(conn, resp) } func setLogLevel(level string) { switch level { case "info": log.SetLevel(log.InfoLevel) case "error": log.SetLevel(log.ErrorLevel) case "verbose": log.SetLevel(log.TraceLevel) // Go's logrus doesn't have 'verbose', using 'Trace' instead case "debug": log.SetLevel(log.DebugLevel) default: log.SetLevel(log.InfoLevel) } log.Infof("Log level set to %s", level) } // recvActions handles incoming actions in a separate goroutine. func receiveActions(conn net.Conn) { for { action, err := receiveAction(conn) if err != nil { if err == io.EOF { fmt.Println("Connection closed by server") return } fmt.Println("Error reading:", err) continue } fmt.Println("Action received:", action) if action["name"] == "update_config" { fmt.Println("update_config action received") updateConfig(conn, action) } } } ``` ::: # Triggering config update On the device management section of Bytebeam Cloud, select the device and click on **Update Configuration** Select the appropriate config. version. Confirm the selection. You should now be able to see the status of the update on the cloud. # App Update Source: https://bytebeam.io/docs/device-side-integrations/linux/integrate-over-the-air-updates/app-update Learn how to update an application binary on a remote device using Bytebeam cloud with this comprehensive guide. It covers essential steps such as setting the application path, incorporating the application into systemd, and creating an update tar file. This guide talks about how to update an application binary of the remote device from the Bytebeam cloud. App update replaces the existing binary on the system with the binary uploaded on the Bytebeam cloud. We have provided an example application on our [Github](https://github.com/bytebeamio/uplink/tree/main/examples/rpi/updates/app_update) page. There are four files in the example. * **hello\_app** - Prints "Hello from Bytebeam" every 3 seconds. * **app\_update.sh** - This script replaces the old application with new application. * **update.sh** - This is a wrapper script for app\_update.sh script. * **make\_firmware\_update.sh** - It creates the update tar file. ## Step1: Prepare update tar Firstly on your Linux system, we need to create an update tar file for Raspberry Pi. For that, Download all the files mentioned above from GitHub. Next, we need to change the permissions for all these files using `chmod` command ```shell theme={null} chmod a+x hello_app chmod a+x app_update.sh chmod a+x update.sh chmod a+x make_firmware_update.sh ``` Next run **make\_firmware\_update.sh** to create a tar.gz file. ```shell theme={null} ./make_firmware_update.sh ``` ## Step 2: upload update Tar Next, we need to upload the tar to [bytebeam cloud.](https://cloud.bytebeam.io/) For that go to device management panel and click on the **Firmware Versions** tab. Under the Firmware version tab, you will find an option to create a firmware version number and upload your updated tar file. Enter the new **Firmware version number** and click on **choose file** to upload tar file. Then click on **Create.** ## Step 3: Set the application path In **step 1** we have already assumed that you want to update\*\* **the** hello\_app\*\* that exists on your remote device and we created an update tar accordingly. On the remote device, the app is expected to be in **/usr/local/bin** location. If it's not there then create a new **hello\_app** in **/usr/local/bin.** ```shell theme={null} #!/bin/bash while [ 1 ] do sleep 3 echo "Hi from Bytebeam" done ``` If the application location and
[...]
